//================================================
// Cross and Null
// Alex A. Trubetskoy, 2002, alextr438@yandex.ru
//================================================

#define STRICT
#include <windows.h>
#include "crossnull.h"
#include "resource.h"
#include "CrossNullField.h"

char const szMainClassName[]    = "CrossAppClass";
char const szMainWindowTitle[]  = "Cross and Null";

HINSTANCE hInst;

// =====================================
//  WinMain
// =====================================
int PASCAL
WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
	LPSTR lpszCmdLine, int nCmdShow)  
{
	MSG  msg;
	HWND hwnd;
	hInst = hInstance;
	HBITMAP hBmp   = LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_BITMAP_BACK));
	HBRUSH hBrush  = CreatePatternBrush(hBmp);
	CCrossNullField::setBmpC(LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_BITMAPC)));
	CCrossNullField::setBmpN(LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_BITMAPN)));
	CCrossNullField::setBmpE(LoadBitmap(hInstance, MAKEINTRESOURCE(IDB_BITMAPE)));

	if(!Register(hInstance, hBrush))
		return FALSE;

	hwnd = CreateWindow(
		szMainClassName,     //   
		szMainWindowTitle,   //  
		WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
		140, 80, 550, 400,
		0,                   //   
		0,                   //  
		hInstance,           //  
		NULL);               

	if(!hwnd)
		return FALSE;

	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);

	CreateWindow("button", "Begin",
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
		110, 320,
		90, 30,
		hwnd,
		(HMENU) IDB_BUTTON1,
		hInstance, NULL);
	CreateWindow("button", "About",
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
		230, 320,
		90, 30,
		hwnd,
		(HMENU) IDB_BUTTON2,
		hInstance, NULL);
	CreateWindow("button", "Cancel",
		WS_CHILD | WS_VISIBLE | BS_PUSHBUTTON,
		350, 320,
		90, 30,
		hwnd,
		(HMENU) IDB_BUTTON3,
		hInstance, NULL);

	while(GetMessage(&msg, 0, 0, 0)) 
	{
		DispatchMessage(&msg);
	}

	DeleteObject(hBmp);
	DeleteObject(hBrush);
	CCrossNullField::deleteBmpC(); 
	CCrossNullField::deleteBmpN();
	CCrossNullField::deleteBmpE();

	return msg.wParam;
}

BOOL Register(HINSTANCE hInstance, HBRUSH hBrush) 
{
	ATOM aWndClass;             //    
	WNDCLASS wc;                //   
                              //  
	memset(&wc, 0, sizeof(wc));
	wc.style = 0;
	wc.lpfnWndProc   = (WNDPROC) WndProc;
	wc.cbClsExtra    = 0;
	wc.cbWndExtra    = 0;
	wc.hInstance     = hInstance;
	wc.hIcon         = LoadIcon(hInstance, MAKEINTRESOURCE(IDI_ICON1));
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = hBrush;
	wc.lpszMenuName  = (LPSTR)NULL;
	wc.lpszClassName = (LPSTR)szMainClassName;
	aWndClass = RegisterClass(&wc);

	if(aWndClass == 0) 
		return FALSE;

	return TRUE;
}





