//================================================
// Cross and Null
// Alex A. Trubetskoy, 2002, alextr438@yandex.ru
//================================================

#include "CrossNullField.h"

#define SIGN_NULL		1		// ,      
#define SIGN_CROSS		2		// ,      

HBITMAP CCrossNullField::hBmpE = (HBITMAP)0;
HBITMAP CCrossNullField::hBmpC = (HBITMAP)0;
HBITMAP CCrossNullField::hBmpN = (HBITMAP)0;

void CCrossNullField::repaint(HDC hdc)
{
	int y = 50, x;
	for(int i = 0; i < 3; ++i) 
	{
		x = 150;
		for(int j = 0; j < 3; ++j) 
		{
			switch(sq[i][j])
			{
				case 0: 
					drawBitmap(x, y, hBmpE); break;
				case SIGN_NULL:   
					drawBitmap(x, y, hBmpN); break;
				case SIGN_CROSS: 
					drawBitmap(x, y, hBmpC); break;
			}	
			x += 70;
		}
		y += 70;
	}
}

void CCrossNullField::clearField()
{
	int y = 50, x;
	for(int i = 0; i < 3; ++i) 
	{
		x = 150;
		for(int j = 0; j < 3; ++j) 
		{
			drawBitmap(x, y, hBmpE);   //paint an empty cell
			x += 70;
		}
		y += 70;
	}
	for(int i = 0; i < 3; ++i)
		for(int j = 0; j < 3; ++j)
			sq[i][j] = 0;

	end = false;
}

void CCrossNullField::showFigure(POINT pt)
{
	if(end) 
		return;

	if(pt.x>150 && pt.x<220 && pt.y>50 && pt.y<120 && !sq[0][0]) 
	{
		drawBitmap(150, 50, hBmpN);
		sq[0][0] = SIGN_NULL;
	}
	else
	if(pt.x>220 && pt.x<290 && pt.y>50 && pt.y<120 && !sq[0][1]) 
	{
		drawBitmap(220, 50, hBmpN);
		sq[0][1] = SIGN_NULL;
	}
	else
	if(pt.x>290 && pt.x<360 && pt.y>50 && pt.y<120 && !sq[0][2]) 
	{
		drawBitmap(290, 50, hBmpN);
		sq[0][2] = SIGN_NULL;
	}
	else
	if(pt.x>150 && pt.x<220 && pt.y>120 && pt.y<190 && !sq[1][0]) 
	{
		drawBitmap(150, 120, hBmpN);
		sq[1][0] = SIGN_NULL;
	}
	else
	if(pt.x>220 && pt.x<290 && pt.y>120 && pt.y<190 && !sq[1][1]) 
	{
		drawBitmap(220, 120, hBmpN);
		sq[1][1] = SIGN_NULL;
	}
	else
	if(pt.x>290 && pt.x<360 && pt.y>120 && pt.y<190 && !sq[1][2]) 
	{
		drawBitmap(290, 120, hBmpN);
		sq[1][2] = SIGN_NULL;
	}
	else
	if(pt.x>150 && pt.x<220 && pt.y>190 && pt.y<260 && !sq[2][0]) 
	{
		drawBitmap(150, 190, hBmpN);
		sq[2][0] = SIGN_NULL;
	}
	else
	if(pt.x>220 && pt.x<290 && pt.y>190 && pt.y<260 && !sq[2][1]) {
		drawBitmap(220, 190, hBmpN);
		sq[2][1] = SIGN_NULL;
	}
	else
	if(pt.x>290 && pt.x<360 && pt.y>190 && pt.y<260 && !sq[2][2]) {
		drawBitmap(290, 190, hBmpN);
		sq[2][2] = SIGN_NULL;
	}
	else 
		return;

	if((sq[0][0] == SIGN_NULL && sq[0][1] == SIGN_NULL && sq[0][2] == SIGN_NULL)||
		(sq[1][0] == SIGN_NULL && sq[1][1] == SIGN_NULL && sq[1][2] == SIGN_NULL)||
		(sq[2][0] == SIGN_NULL && sq[2][1] == SIGN_NULL && sq[2][2] == SIGN_NULL)||
		(sq[0][0] == SIGN_NULL && sq[1][1] == SIGN_NULL && sq[2][2] == SIGN_NULL)||
		(sq[2][0] == SIGN_NULL && sq[1][1] == SIGN_NULL && sq[0][2] == SIGN_NULL)||
		(sq[0][0] == SIGN_NULL && sq[1][0] == SIGN_NULL && sq[2][0] == SIGN_NULL)||
		(sq[0][1] == SIGN_NULL && sq[1][1] == SIGN_NULL && sq[2][1] == SIGN_NULL)||
		(sq[0][2] == SIGN_NULL && sq[1][2] == SIGN_NULL && sq[2][2] == SIGN_NULL))
	{
		MessageBox(NULL, "You've won!", "The ehd", MB_OK);
		end = true;
		return;
	}

	//  
	setCross();

	if((sq[0][0] == SIGN_CROSS && sq[0][1] == SIGN_CROSS && sq[0][2] == SIGN_CROSS)||
		(sq[1][0] == SIGN_CROSS && sq[1][1] == SIGN_CROSS && sq[1][2] == SIGN_CROSS)||
		(sq[2][0] == SIGN_CROSS && sq[2][1] == SIGN_CROSS && sq[2][2] == SIGN_CROSS)||
		(sq[0][0] == SIGN_CROSS && sq[1][1] == SIGN_CROSS && sq[2][2] == SIGN_CROSS)||
		(sq[2][0] == SIGN_CROSS && sq[1][1] == SIGN_CROSS && sq[0][2] == SIGN_CROSS)||
		(sq[0][0] == SIGN_CROSS && sq[1][0] == SIGN_CROSS && sq[2][0] == SIGN_CROSS)||
		(sq[0][1] == SIGN_CROSS && sq[1][1] == SIGN_CROSS && sq[2][1] == SIGN_CROSS)||
		(sq[0][2] == SIGN_CROSS && sq[1][2] == SIGN_CROSS && sq[2][2] == SIGN_CROSS))
	{
		MessageBox(NULL, "I've won!", "The ehd", MB_OK);
		end = true;
	}
}

void CCrossNullField::setCross()
{
	int i, j, i2, j2;

    //  
	getNeedPosition(&i, &j, SIGN_NULL);
    //  :
    getNeedPosition(&i2, &j2, SIGN_CROSS);

	if(i2 != -1 && j2 != -1)
	{
		i = i2;
		j = j2;
	}

    //  
    if(i == -1) 
	{
       if(!sq[1][1]){i = 1; j = 1;}
       else
       if(!sq[0][0]){i = 0; j = 0;}
       else
       if(!sq[2][2]){i = 2; j = 2;}
       else
       if(!sq[0][2]){i = 0; j = 2;}
       else
       if(!sq[2][0]){i = 2; j = 0;}
       else
       if(!sq[0][1]){i = 0; j = 1;}
       else
       if(!sq[1][0]){i = 1; j = 0;}
       else
       if(!sq[1][2]){i = 1; j = 2;}
       else
       if(!sq[2][1]){i = 2; j = 1;}
    }

    // 
    if(i != -1 && j != -1) 
	{
		int x = 150, y = 50;
		for(int k = 0; k < 3; ++k) 
		{
			for(int m = 0; m < 3; ++m) 
			{
				if(i == k && j == m) 
				{
					drawBitmap(x, y, hBmpC);
					sq[i][j] = SIGN_CROSS;
					return;
				}
				x += 70;
			}
			x = 150; y += 70;
		}
    }
}

void CCrossNullField::getNeedPosition(int* pi, int* pj, int type) const
{
	*pi = -1;
    *pj = -1;

    // 
    for(int i = 0; i < 3; ++i) 
	{
		if(sq[i][0] == type && sq[i][1] == type && !sq[i][2])
		{
			*pi = i; 
			*pj = 2;
		}
		else
		if(sq[i][0] == type && sq[i][2] == type && !sq[i][1])
		{
			*pi = i; 
			*pj = 1;
		}
		else
		if(sq[i][1] == type && sq[i][2] == type && !sq[i][0])
		{
			*pi = i; 
			*pj = 0;
		}
    }
    // 
	for(int i = 0; i < 3; ++i) 
	{
		if(sq[0][i] == type && sq[1][i] == type && !sq[2][i])
		{
			*pi = 2; 
			*pj = i;
		}
		else
		if(sq[0][i] == type && sq[2][i] == type && !sq[1][i])
		{
			*pi = 1; 
			*pj = i;
		}
		else
		if(sq[1][i] == type && sq[2][i] == type && !sq[0][i])
		{
			*pi = 0; 
			*pj = i;
		}
    }
    // 
	if(sq[0][0] == type && sq[1][1] == type && !sq[2][2])
	{
		*pi = 2; 
		*pj = 2;
	}
	else
	if(sq[0][0] == type && sq[2][2] == type && !sq[1][1])
	{
		*pi = 1; 
		*pj = 1;
	}
	else
	if(sq[1][1] == type && sq[2][2] == type && !sq[0][0])
	{
		*pi = 0; 
		*pj = 0;
	}
    // 
    if(sq[0][2] == type && sq[1][1] == type && !sq[2][0])
	{
		*pi = 2; 
		*pj = 0;
	}
	else
	if(sq[0][2] == type && sq[2][0] == type && !sq[1][1])
	{
		*pi = 1; 
		*pj = 1;
	}
	else
	if(sq[1][1] == type && sq[2][0] == type && !sq[0][2])
	{
		*pi = 0; 
		*pj = 2;
	}

	if(*pi != -1 && *pj != -1)
	{
		if(sq[*pi][*pj] != 0)
		{
			*pi = -1;
			*pj = -1;
		}
	}
}

//  bitmap
void CCrossNullField::drawBitmap(int x, int y, HBITMAP hBitmap) 
{
	HDC hDCMemory;
	HBITMAP hOldBitmap;
	BITMAP bitmap;
	GetObject(hBitmap, sizeof(BITMAP), &bitmap);
	hDCMemory = CreateCompatibleDC(hdc);
	hOldBitmap = (HBITMAP)SelectObject(hDCMemory,hBitmap);
	BitBlt(hdc, x, y, bitmap.bmWidth, bitmap.bmHeight,
                                  hDCMemory, 0, 0, SRCCOPY);
	SelectObject(hDCMemory, hOldBitmap);
	DeleteDC(hDCMemory);
}
