//================================================
// Cross and Null
// Alex A. Trubetskoy, 2002, alextr438@yandex.ru
//================================================

#ifndef CROSS_NULL_FIELD
#define CROSS_NULL_FIELD

#include <windows.h>

class CCrossNullField
{
	int sq[3][3];         //the field
	HDC hdc;

	static HBITMAP hBmpE;
	static HBITMAP hBmpC;
	static HBITMAP hBmpN;

	bool end;

public:
	CCrossNullField(): end(false) {}
	void repaint(HDC hdc);
	void clearField();
	void setHdc(HDC h) { hdc = h; }
	void releaseHdc(HWND hwnd) { ReleaseDC(hwnd, hdc); }
	void showFigure(POINT pos);
	void setCross();
	void drawBitmap(int x, int y, HBITMAP hBitmap);
	void getNeedPosition(int* pi, int* pj, int type) const;

	static void setBmpE(HBITMAP h) { hBmpE = h; }
	static void setBmpC(HBITMAP h) { hBmpC = h; }
	static void setBmpN(HBITMAP h) { hBmpN = h; }
	static void deleteBmpC() { DeleteObject(hBmpC); } 
	static void deleteBmpN() { DeleteObject(hBmpN); } 
	static void deleteBmpE() { DeleteObject(hBmpE); } 
};

#endif
