//================================================
// Cross and Null
// Alex A. Trubetskoy, 2002, alextr438@yandex.ru
//================================================

#define STRICT
#include <windows.h>
#include "crossnull.h"
#include "resource.h"
#include "CrossNullField.h"

CCrossNullField field;
extern HINSTANCE hInst;

//----------------------------------
// Window procedure
//----------------------------------
LRESULT CALLBACK
WndProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam) 
{
	HDC hdc;
	PAINTSTRUCT ps;
	static DLGPROC lpfnDlgProc;
  
	switch (msg) 
	{
		case WM_CREATE:
			field.setHdc(GetDC(hwnd));

		case WM_PAINT:
			hdc = BeginPaint(hwnd, &ps);
			field.repaint(hdc);
			EndPaint(hwnd, &ps);
			return 0;

		case WM_COMMAND: 
			if(wParam == IDB_BUTTON1) 
			{
				field.clearField();
			}
			if(wParam == IDB_BUTTON2) 
			{
				lpfnDlgProc = (DLGPROC)MakeProcInstance((FARPROC)DlgProc, hInst);
				DialogBox(hInst, MAKEINTRESOURCE(DLG_ABOUT), hwnd, lpfnDlgProc);
			}
			if(wParam == IDB_BUTTON3) 
			{
				PostQuitMessage(0);
			}
			return 0;

		case WM_LBUTTONDOWN:
			field.showFigure(getCursorPosition(hwnd));
			return 0;
    
		case WM_DESTROY:
			field.releaseHdc(hwnd);
			PostQuitMessage(0);
			return 0;
	}
	return DefWindowProc(hwnd, msg, wParam, lParam);
}

BOOL CALLBACK
DlgProc(HWND hdlg, UINT msg, WPARAM wParam, LPARAM lParam) 
{
	switch(msg) 
	{
		case WM_INITDIALOG: 
			return TRUE;
   
		case WM_COMMAND: 
			switch(wParam)
			{
				case IDOK:
				case IDCANCEL: 
					EndDialog(hdlg, 0);
					return TRUE;
			}
	}
	return FALSE;
}

//calculate the cursor's position
POINT getCursorPosition(HWND hwnd) 
{
	RECT rc;
	POINT ptS, ptW;
	GetWindowRect(hwnd, &rc);
	GetCursorPos(&ptS);
	ptW.x = ptS.x - rc.left;
	ptW.y = ptS.y - rc.top - 20;
	return ptW;
}
